- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- File List
- File Members

# /home/coin/SVN-release/DyLP-1.5.0/DyLP/src/Dylp/dy_consys.h File Reference

`#include "dy_vector.h"`
`#include "dylib_io.h"`
`#include "dylib_std.h"`

Include dependency graph for dy_consys.h:

This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Classes
struct | coeff_struct_tag
struct | colhdr_struct_tag
struct | rowhdr_struct_tag
struct | conmtx_struct
struct | attvhdr_struct_tag
struct | conbnd_struct
struct | consys_struct
## Defines
#define | CONSYS_MTX ((flags) 1<<0)
#define | CONSYS_ROW ((flags) 1<<1)
#define | CONSYS_COL ((flags) 1<<2)
#define | CONSYS_OBJ ((flags) 1<<3)
#define | CONSYS_VUB ((flags) 1<<4)
#define | CONSYS_VLB ((flags) 1<<5)
#define | CONSYS_RHS ((flags) 1<<6)
#define | CONSYS_CUB ((flags) 1<<7)
#define | CONSYS_CLB ((flags) 1<<8)
#define | CONSYS_RHSLOW ((flags) 1<<9)
#define | CONSYS_VTYP ((flags) 1<<10)
#define | CONSYS_CTYP ((flags) 1<<11)
#define | CONSYS_COLHDR ((flags) 1<<12)
#define | CONSYS_ROWHDR ((flags) 1<<13)
#define | CONSYS_RSCALE ((flags) 1<<14)
#define | CONSYS_CSCALE ((flags) 1<<15)
#define | CONSYS_ROWVEC
#define | CONSYS_COLVEC
#define | VALID_ATTVTYPE(zz_vectype_zz)
#define | VALID_CONTYPE(zz_ctyp_zz)
#define | VALID_VARTYPE(zz_vtyp_zz)
#define | INT_VARTYPE(zz_vtyp_zz)
#define | CONSYS_LVARS ((flags) 1<<0)
#define | CONSYS_WRNZERO ((flags) 1<<1)
#define | CONSYS_WRNATT ((flags) 1<<2)
#define | CONSYS_FININF ((flags) 1<<3)
#define | CONSYS_CORRUPT ((flags) 1<<4)
#define | CONSYS_MAXBUFLEN 32
## Typedefs
typedef coeff_struct_tag | coeff_struct
typedef colhdr_struct_tag | colhdr_struct
typedef rowhdr_struct_tag | rowhdr_struct
typedef attvhdr_struct_tag | attvhdr_struct
## Enumerations
enum | contyp_enum { contypINV = 0, contypNB, contypGE, contypEQ, contypLE, contypRNG }
enum | vartyp_enum { vartypINV = 0, vartypCON, vartypINT, vartypBIN }
## Functions
consys_struct * | consys_create (const char *nme, flags parts, flags opts, int concnt, int varcnt, double infinity)
bool | consys_dupsys (consys_struct *src, consys_struct **dst, flags dstvecs)
void | consys_free (consys_struct *consys)
bool | consys_realloc (consys_struct *consys, char rowcol, int incr)
bool | consys_attach (consys_struct *consys, flags what, int elsze, void **pvec)
bool | consys_update (consys_struct *consys, void *oldvec, void *newvec)
bool | consys_detach (consys_struct *consys, void **pvec, bool all)
bool | consys_addcol_pk (consys_struct *consys, vartyp_enum vartyp, pkvec_struct *pkcol, double obj, double vlb, double vub)
bool | consys_addcol_ex (consys_struct *consys, vartyp_enum vartyp, const char **nme, double *excol, double obj, double vlb, double vub)
bool | consys_addrow_pk (consys_struct *consys, char rowclass, contyp_enum contyp, pkvec_struct *pkrow, double rhs, double rhslow, conbnd_struct *cub, conbnd_struct *clb)
bool | consys_getcol_pk (consys_struct *consys, int colndx, pkvec_struct **pkvec)
bool | consys_getcol_ex (consys_struct *consys, int colndx, double **vec)
bool | consys_getrow_pk (consys_struct *consys, int rowndx, pkvec_struct **pkvec)
bool | consys_getrow_ex (consys_struct *consys, int rowndx, double **vec)
bool | consys_delcol (consys_struct *consys, int colndx)
bool | consys_delrow (consys_struct *consys, int rowndx)
bool | consys_delrow_stable (consys_struct *consys, int rowndx)
bool | consys_setcoeff (consys_struct *consys, int rowndx, int colndx, double val)
double | consys_getcoeff (consys_struct *consys, int rowndx, int colndx)
bool | consys_logicals (consys_struct *consys)
int | consys_gcdrow (consys_struct *consys, int rowndx)
double | consys_dotcol (consys_struct *consys, int colndx, double *vec)
double | consys_dotrow (consys_struct *consys, int rowndx, double *vec)
double | consys_1normrow (consys_struct *consys, int rowndx)
double | consys_ssqrow (consys_struct *consys, int rowndx)
double | consys_2normrow (consys_struct *consys, int rowndx)
double | consys_infnormrow (consys_struct *consys, int rowndx)
double | consys_1normcol (consys_struct *consys, int rowndx)
double | consys_ssqcol (consys_struct *consys, int rowndx)
double | consys_2normcol (consys_struct *consys, int rowndx)
double | consys_infnormcol (consys_struct *consys, int rowndx)
bool | consys_mulrow (consys_struct *consys, int rowndx, double scalar)
bool | consys_divrow (consys_struct *consys, int rowndx, double scalar)
bool | consys_accumcol (consys_struct *consys, int colndx, double *vec)
bool | consys_mulaccumcol (consys_struct *consys, int colndx, double scalar, double *vec)
bool | consys_evalsys (consys_struct *consys, double *scm, int *gecnt)
bool | consys_geomscale (consys_struct *consys, double **rowscale, double **colscale)
bool | consys_equiscale (consys_struct *consys, double **rowscale, double **colscale)
bool | consys_applyscale (consys_struct *consys, bool convctyp, double *rowscale, double *colscale)
const char * | consys_prtvartyp (vartyp_enum vartyp)
const char ** | consys_prtcontyp (contyp_enum contyp)
char * | consys_assocnme (consys_struct *consys, flags which)
char ** | consys_conbndnme (char bndlett, int cndx, conbnd_struct *bnd)
char *** | consys_conbndval (conbnd_struct *bnd)
void | consys_prtcon (ioid chn, bool echo, consys_struct *consys, int i, const char *pfx)
void | consys_chgnme (consys_struct *consys, char cv, int ndx, const char *newnme)
const char * | consys_nme (consys_struct *consys, char cv, int ndx, bool pfx, char *clientbuf)

## Define Documentation

#define CONSYS_MTX ((flags) 1<<0)

Definition at line 208 of file dy_consys.h.

#define CONSYS_ROW ((flags) 1<<1)

Definition at line 209 of file dy_consys.h.

#define CONSYS_COL ((flags) 1<<2)

Definition at line 210 of file dy_consys.h.

#define CONSYS_OBJ ((flags) 1<<3)

Definition at line 211 of file dy_consys.h.

#define CONSYS_VUB ((flags) 1<<4)

Definition at line 212 of file dy_consys.h.

#define CONSYS_VLB ((flags) 1<<5)

Definition at line 213 of file dy_consys.h.

#define CONSYS_RHS ((flags) 1<<6)

Definition at line 214 of file dy_consys.h.

#define CONSYS_CUB ((flags) 1<<7)

Definition at line 215 of file dy_consys.h.

#define CONSYS_CLB ((flags) 1<<8)

Definition at line 216 of file dy_consys.h.

#define CONSYS_RHSLOW ((flags) 1<<9)

Definition at line 217 of file dy_consys.h.

#define CONSYS_VTYP ((flags) 1<<10)

Definition at line 218 of file dy_consys.h.

#define CONSYS_CTYP ((flags) 1<<11)

Definition at line 219 of file dy_consys.h.

#define CONSYS_COLHDR ((flags) 1<<12)

Definition at line 220 of file dy_consys.h.

#define CONSYS_ROWHDR ((flags) 1<<13)

Definition at line 221 of file dy_consys.h.

#define CONSYS_RSCALE ((flags) 1<<14)

Definition at line 222 of file dy_consys.h.

#define CONSYS_CSCALE ((flags) 1<<15)

Definition at line 223 of file dy_consys.h.

#define CONSYS_ROWVEC

Value:

    (CONSYS_OBJ|CONSYS_VUB|CONSYS_VLB|CONSYS_VTYP|CONSYS_CSCALE| \
       CONSYS_COLHDR|CONSYS_ROW)

Definition at line 228 of file dy_consys.h.

#define CONSYS_COLVEC

Value:

    (CONSYS_RHS|CONSYS_RHSLOW|CONSYS_CUB|CONSYS_CLB|CONSYS_CTYP|CONSYS_RSCALE| \
       CONSYS_ROWHDR|CONSYS_COL)

Definition at line 232 of file dy_consys.h.

#define VALID_ATTVTYPE | ( | zz_vectype_zz |  | ) |

Value:

    (zz_vectype_zz == CONSYS_OBJ || \
       zz_vectype_zz == CONSYS_VUB || zz_vectype_zz == CONSYS_VLB || \
       zz_vectype_zz == CONSYS_RHS || zz_vectype_zz == CONSYS_RHSLOW || \
       zz_vectype_zz == CONSYS_CUB || zz_vectype_zz == CONSYS_CUB || \
       zz_vectype_zz == CONSYS_VTYP || zz_vectype_zz == CONSYS_CTYP || \
       zz_vectype_zz == CONSYS_RSCALE || zz_vectype_zz == CONSYS_CSCALE || \
       zz_vectype_zz == CONSYS_ROW || zz_vectype_zz == CONSYS_COL)

Definition at line 240 of file dy_consys.h.

#define VALID_CONTYPE | ( | zz_ctyp_zz |  | ) |

Value:

    (zz_ctyp_zz == contypGE || zz_ctyp_zz == contypEQ || \
       zz_ctyp_zz == contypLE || zz_ctyp_zz == contypRNG)

Definition at line 341 of file dy_consys.h.

#define VALID_VARTYPE | ( | zz_vtyp_zz |  | ) |

Value:

    (zz_vtyp_zz == vartypCON || \
       zz_vtyp_zz == vartypINT || \
       zz_vtyp_zz == vartypBIN)

Definition at line 357 of file dy_consys.h.

#define INT_VARTYPE | ( | zz_vtyp_zz |  | ) |

Value:

    (zz_vtyp_zz == vartypINT || \
       zz_vtyp_zz == vartypBIN)

Definition at line 362 of file dy_consys.h.

#define CONSYS_LVARS ((flags) 1<<0)

Definition at line 394 of file dy_consys.h.

#define CONSYS_WRNZERO ((flags) 1<<1)

Definition at line 395 of file dy_consys.h.

#define CONSYS_WRNATT ((flags) 1<<2)

Definition at line 396 of file dy_consys.h.

#define CONSYS_FININF ((flags) 1<<3)

Definition at line 397 of file dy_consys.h.

#define CONSYS_CORRUPT ((flags) 1<<4)

Definition at line 398 of file dy_consys.h.

#define CONSYS_MAXBUFLEN 32

Definition at line 625 of file dy_consys.h.

## Typedef Documentation

typedef struct coeff_struct_tag coeff_struct

typedef struct colhdr_struct_tag colhdr_struct

typedef struct rowhdr_struct_tag rowhdr_struct

typedef struct attvhdr_struct_tag attvhdr_struct

## Enumeration Type Documentation

enum contyp_enum

Enumerator:

  contypINV |
  contypNB |
  contypGE |
  contypEQ |
  contypLE |
  contypRNG |

Definition at line 338 of file dy_consys.h.

enum vartyp_enum

Enumerator:

  vartypINV |
  vartypCON |
  vartypINT |
  vartypBIN |

Definition at line 354 of file dy_consys.h.

## Function Documentation

consys_struct* consys_create | ( | const char * | nme,
|  | flags | parts,
|  | flags | opts,
|  | int | concnt,
|  | int | varcnt,
|  | double | infinity |
| ) |  |  |

bool consys_dupsys | ( | consys_struct * | src,
|  | consys_struct ** | dst,
|  | flags | dstvecs |
| ) |  |  |

void consys_free | ( | consys_struct * | consys | ) |

bool consys_realloc | ( | consys_struct * | consys,
|  | char | rowcol,
|  | int | incr |
| ) |  |  |

bool consys_attach | ( | consys_struct * | consys,
|  | flags | what,
|  | int | elsze,
|  | void ** | pvec |
| ) |  |  |

bool consys_update | ( | consys_struct * | consys,
|  | void * | oldvec,
|  | void * | newvec |
| ) |  |  |

bool consys_detach | ( | consys_struct * | consys,
|  | void ** | pvec,
|  | bool | all |
| ) |  |  |

bool consys_addcol_pk | ( | consys_struct * | consys,
|  | vartyp_enum | vartyp,
|  | pkvec_struct * | pkcol,
|  | double | obj,
|  | double | vlb,
|  | double | vub |
| ) |  |  |

bool consys_addcol_ex | ( | consys_struct * | consys,
|  | vartyp_enum | vartyp,
|  | const char ** | nme,
|  | double * | excol,
|  | double | obj,
|  | double | vlb,
|  | double | vub |
| ) |  |  |

bool consys_addrow_pk | ( | consys_struct * | consys,
|  | char | rowclass,
|  | contyp_enum | contyp,
|  | pkvec_struct * | pkrow,
|  | double | rhs,
|  | double | rhslow,
|  | conbnd_struct * | cub,
|  | conbnd_struct * | clb |
| ) |  |  |

bool consys_getcol_pk | ( | consys_struct * | consys,
|  | int | colndx,
|  | pkvec_struct ** | pkvec |
| ) |  |  |

bool consys_getcol_ex | ( | consys_struct * | consys,
|  | int | colndx,
|  | double ** | vec |
| ) |  |  |

bool consys_getrow_pk | ( | consys_struct * | consys,
|  | int | rowndx,
|  | pkvec_struct ** | pkvec |
| ) |  |  |

bool consys_getrow_ex | ( | consys_struct * | consys,
|  | int | rowndx,
|  | double ** | vec |
| ) |  |  |

bool consys_delcol | ( | consys_struct * | consys,
|  | int | colndx |
| ) |  |  |

bool consys_delrow | ( | consys_struct * | consys,
|  | int | rowndx |
| ) |  |  |

bool consys_delrow_stable | ( | consys_struct * | consys,
|  | int | rowndx |
| ) |  |  |

bool consys_setcoeff | ( | consys_struct * | consys,
|  | int | rowndx,
|  | int | colndx,
|  | double | val |
| ) |  |  |

double consys_getcoeff | ( | consys_struct * | consys,
|  | int | rowndx,
|  | int | colndx |
| ) |  |  |

bool consys_logicals | ( | consys_struct * | consys | ) |

int consys_gcdrow | ( | consys_struct * | consys,
|  | int | rowndx |
| ) |  |  |

double consys_dotcol | ( | consys_struct * | consys,
|  | int | colndx,
|  | double * | vec |
| ) |  |  |

double consys_dotrow | ( | consys_struct * | consys,
|  | int | rowndx,
|  | double * | vec |
| ) |  |  |

double consys_1normrow | ( | consys_struct * | consys,
|  | int | rowndx |
| ) |  |  |

double consys_ssqrow | ( | consys_struct * | consys,
|  | int | rowndx |
| ) |  |  |

double consys_2normrow | ( | consys_struct * | consys,
|  | int | rowndx |
| ) |  |  |

double consys_infnormrow | ( | consys_struct * | consys,
|  | int | rowndx |
| ) |  |  |

double consys_1normcol | ( | consys_struct * | consys,
|  | int | rowndx |
| ) |  |  |

double consys_ssqcol | ( | consys_struct * | consys,
|  | int | rowndx |
| ) |  |  |

double consys_2normcol | ( | consys_struct * | consys,
|  | int | rowndx |
| ) |  |  |

double consys_infnormcol | ( | consys_struct * | consys,
|  | int | rowndx |
| ) |  |  |

bool consys_mulrow | ( | consys_struct * | consys,
|  | int | rowndx,
|  | double | scalar |
| ) |  |  |

bool consys_divrow | ( | consys_struct * | consys,
|  | int | rowndx,
|  | double | scalar |
| ) |  |  |

bool consys_accumcol | ( | consys_struct * | consys,
|  | int | colndx,
|  | double * | vec |
| ) |  |  |

bool consys_mulaccumcol | ( | consys_struct * | consys,
|  | int | colndx,
|  | double | scalar,
|  | double * | vec |
| ) |  |  |

bool consys_evalsys | ( | consys_struct * | consys,
|  | double * | scm,
|  | int * | gecnt |
| ) |  |  |

bool consys_geomscale | ( | consys_struct * | consys,
|  | double ** | rowscale,
|  | double ** | colscale |
| ) |  |  |

bool consys_equiscale | ( | consys_struct * | consys,
|  | double ** | rowscale,
|  | double ** | colscale |
| ) |  |  |

bool consys_applyscale | ( | consys_struct * | consys,
|  | bool | convctyp,
|  | double * | rowscale,
|  | double * | colscale |
| ) |  |  |

const char* consys_prtvartyp | ( | vartyp_enum | vartyp | ) |

const char* * consys_prtcontyp | ( | contyp_enum | contyp | ) |

char* consys_assocnme | ( | consys_struct * | consys,
|  | flags | which |
| ) |  |  |

char* * consys_conbndnme | ( | char | bndlett,
|  | int | cndx,
|  | conbnd_struct * | bnd |
| ) |  |  |

char* * * consys_conbndval | ( | conbnd_struct * | bnd | ) |

void consys_prtcon | ( | ioid | chn,
|  | bool | echo,
|  | consys_struct * | consys,
|  | int | i,
|  | const char * | pfx |
| ) |  |  |

void consys_chgnme | ( | consys_struct * | consys,
|  | char | cv,
|  | int | ndx,
|  | const char * | newnme |
| ) |  |  |

const char* consys_nme | ( | consys_struct * | consys,
|  | char | cv,
|  | int | ndx,
|  | bool | pfx,
|  | char * | clientbuf |
| ) |  |  |